"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const mutationState_1 = require("@graphprotocol/mutations/dist/mutationState");
const react_1 = require("react");
const react_hooks_1 = require("@apollo/react-hooks");
exports.useMutation = (mutation, options) => {
    const [state, setState] = react_1.useState({});
    const [observable] = react_1.useState(new mutationState_1.MutationStatesSub({}));
    const graphContext = {
        _rootSub: observable,
    };
    const updatedOptions = options
        ? Object.assign(Object.assign({}, options), { context: Object.assign(Object.assign(Object.assign({}, options.context), { client: options.client }), graphContext) }) : {
        context: Object.assign({}, graphContext),
    };
    const [execute, result] = react_hooks_1.useMutation(mutation, updatedOptions);
    react_1.useEffect(() => {
        let subscription = observable.subscribe((result) => {
            if (result) {
                setState(result);
            }
        });
        return () => subscription.unsubscribe();
    }, [observable, setState]);
    return [
        execute,
        Object.assign(Object.assign({}, result), { state }),
    ];
};
exports.Mutation = (props) => {
    const [runMutation, result] = exports.useMutation(props.mutation, props);
    return props.children ? props.children(runMutation, result) : null;
};
//# sourceMappingURL=index.js.map